% 
%INPUTS:
%   img         -   retinal image
%   mask        -   FOV mask image
%   weights     -   weights for each filter : [w1*MF, w2*FR, w3*GW, w4*CS]. Range [0..1] and sum is equal 1 ;
%OUTPUT:
%   BW- segmented retinal image

function BW = weightedMeanByFCM(img, mask, weights)

    se = strel('disk',5);
    mask = imerode(mask,se);
    mask = mask*255;


    filteredImage = weightedMean(img, mask, weights);


    [Sx Sy Sz] = size(img);


    input = filteredImage(mask==255);

    [center,U,obj_fcn] = fcm(input,2);

    [maximum, result] = max(U,[],1);


    [minimun, index] = min(center);

    [Sx, Sy] = size(mask);

    BW = zeros(Sx,Sy);

    BW(mask==255) = result ~= index;
    BW(mask==0) = 0;

    BW = postProcessing(BW,2);

end

