% 
%INPUTS:
%   img         -   retinal image
%   mask        -   FOV mask image
%   weights     -   weights for each filter : [w1*MF, w2*FR, w3*GW, w4*CS]. Range [0..1] and sum is equal 1 ;
%OUTPUT:
%   BW- segmented retinal image

function BW = weightedMeanByORSF(img, mask, weights)
    if (sum(weights) ~=1)
        return; 
    end 
    
    mask = mask/255;
    se = strel('disk',5);
    mask = imerode(mask,se);
    idx = find(mask==0);

    [Sx, Sy, Sz] = size(img);

    filteredImg = weightedMean(img, mask, weights);
    filteredImg = 1 - filteredImg;
    filteredImg = filteredImg * 255;

    imwrite(img,'imgTemp.bmp');
    
    system('sofka\vessel_tracer_ALL.exe imgTemp.bmp matched 3 -s _vessel -d .');
    
    skelVessel = imread('trace_matched_vessel_binary.png');
  

    skelVessel(idx) = 0;
    skelVessel = double(skelVessel);
    skelVessel = round(skelVessel/255);
    idx1 = find(skelVessel == 255);
    idx2 = find(skelVessel == 0);


    initialLSF = zeros(Sx, Sy);
    initialLSF(idx1) = -2;
    initialLSF(idx2) = 2;

    u = initialLSF;

    lambda1 = 3;
    lambda2 = 3;
    nu = 0.0018*255*255;
    timestep = .1;
    mu = 1;
    epsilon = 1;

    KI = MatchFilterWithGaussDerivativeORSF(filteredImg,1,3,9);

    KONE = MatchFilterWithGaussDerivativeORSF(ones(Sx, Sy),1,3,9);


    filteredImg(idx) = 0;
    KI(idx) = 0;
    KONE(idx) = 0;
    for n=1:50
        u =RSF(u,filteredImg,KONE,KI,nu,timestep,mu,lambda1,lambda2,epsilon);

        u(idx) = 2;

    end
    BW = ones(Sx, Sy);
    BW = u<=0;

    idx = find(mask == 0);
    BW(idx) = 0;
    el = strel('square',2);
    BW= imclose(BW,el);
    BW = postProcessing(BW,2);

end
